3 Node Beam Elements not yet supported

About the development of the FEM module/workbench.

Moderator: bernd

wmayer
Site Admin
Posts: 14640
Joined: Thu Feb 19, 2009 10:32 am

Re: 3 Node Beam Elements not yet supported

Postby wmayer » Mon Dec 12, 2016 11:44 am

git commit 5466568 fixes all the reported problems.
User avatar
makkemal
Posts: 395
Joined: Wed Apr 29, 2015 12:41 pm
Location: South Africa
Contact:

Re: 3 Node Beam Elements not yet supported

Postby makkemal » Mon Dec 12, 2016 12:07 pm

Some enhancement of beam sections allowing user to select circular and pipe beam sections
https://github.com/makkemal/FreeCAD/tree/Beam_sections
User avatar
bernd
Posts: 8233
Joined: Sun Sep 08, 2013 8:07 pm
Location: Zürich, Switzerland

Re: 3 Node Beam Elements not yet supported

Postby bernd » Mon Dec 12, 2016 5:03 pm

wmayer wrote:git commit 5466568 fixes all the reported problems.
brilliant
User avatar
bernd
Posts: 8233
Joined: Sun Sep 08, 2013 8:07 pm
Location: Zürich, Switzerland

Re: 3 Node Beam Elements not yet supported

Postby bernd » Mon Dec 12, 2016 5:05 pm

makkemal wrote:Some enhancement of beam sections allowing user to select circular and pipe beam sections
https://github.com/makkemal/FreeCAD/tree/Beam_sections
included in my dev branch https://github.com/berndhahnebach/FreeC ... meshregion. I have a few minor things but I'm gone fix them right above yours, if you guys don't mind.
User avatar
bernd
Posts: 8233
Joined: Sun Sep 08, 2013 8:07 pm
Location: Zürich, Switzerland

Re: 3 Node Beam Elements not yet supported

Postby bernd » Mon Dec 12, 2016 5:21 pm

bernd wrote:
wmayer wrote:git commit 5466568 fixes all the reported problems.
brilliant
Ahh one thing still remains. We've found a bug in unv reader ...

Code: Select all

# 10 node tetrahedron --> tetra10 ###############
import Fem
tetra10 = Fem.FemMesh()  # a FEM mesh
tetra10.addNode( 6, 12, 18, 1)  # some nodes
tetra10.addNode( 0,  0, 18, 2)
tetra10.addNode(12,  0, 18, 3)
tetra10.addNode( 6,  6,  0, 4)
tetra10.addNode( 3,  6, 18, 5)
tetra10.addNode( 6,  0, 18, 6)
tetra10.addNode( 9,  6, 18, 7)
tetra10.addNode( 6,  9,  9, 8)
tetra10.addNode( 3,  3,  9, 9)
tetra10.addNode( 9,  3,  9,10)
tetra10.addVolume([1, 2, 3, 4, 5, 6, 7, 8, 9, 10], 88)  # a volume with ID: 88
tetra10.Volumes
obj = App.ActiveDocument.addObject("Fem::FemMeshObject","tetra10")
obj.FemMesh = tetra10
obj.FemMesh.Volumes

meshpath = u"/home/hugo/Desktop/femmesh.unv"
tetra10.write(meshpath)
mesh = Fem.read(meshpath)
mesh.Volumes
and even worse, because unv is used in FreeCAD to save FEMmeshes to fcstd files

Code: Select all

################################################################
doc = App.newDocument('mydoc')
import Fem
tetra10 = Fem.FemMesh()  # a FEM mesh
tetra10.addNode( 6, 12, 18, 1)  # some nodes
tetra10.addNode( 0,  0, 18, 2)
tetra10.addNode(12,  0, 18, 3)
tetra10.addNode( 6,  6,  0, 4)
tetra10.addNode( 3,  6, 18, 5)
tetra10.addNode( 6,  0, 18, 6)
tetra10.addNode( 9,  6, 18, 7)
tetra10.addNode( 6,  9,  9, 8)
tetra10.addNode( 3,  3,  9, 9)
tetra10.addNode( 9,  3,  9,10)
tetra10.addVolume([1, 2, 3, 4, 5, 6, 7, 8, 9, 10], 88)  # a volume with ID: 88
tetra10.Volumes
obj = doc.addObject("Fem::FemMeshObject","tetra10")
obj.FemMesh = tetra10
obj.FemMesh.Volumes

doc.saveAs(u"/home/hugo/Desktop/femmesh.fcstd")
App.closeDocument("mydoc")
FreeCAD.open(u"/home/hugo/Desktop/femmesh.fcstd")
App.ActiveDocument.tetra10.FemMesh.Volumes
after reopen the FreeCAD document the FemMesh has changed because the element number of the volume is not 88 but 1 instead.
wmayer
Site Admin
Posts: 14640
Joined: Thu Feb 19, 2009 10:32 am

Re: 3 Node Beam Elements not yet supported

Postby wmayer » Mon Dec 12, 2016 5:49 pm

Ahh one thing still remains. We've found a bug in unv reader ...
Yes, that's the issue I found. But fixing smesh stuff is not my realm.
User avatar
makkemal
Posts: 395
Joined: Wed Apr 29, 2015 12:41 pm
Location: South Africa
Contact:

Re: 3 Node Beam Elements not yet supported

Postby makkemal » Tue Dec 13, 2016 5:37 am

@Bernd
included in my dev branch https://github.com/berndhahnebach/FreeC ... meshregion. I have a few minor things but I'm gone fix them right above yours, if you guys don't mind.
Yes go for it, we are just picking up some low hanging fruit in terms of functionality
User avatar
bernd
Posts: 8233
Joined: Sun Sep 08, 2013 8:07 pm
Location: Zürich, Switzerland

Re: 3 Node Beam Elements not yet supported

Postby bernd » Tue Dec 13, 2016 9:30 am

makkemal wrote:Some enhancement of beam sections allowing user to select circular and pipe beam sections
https://github.com/makkemal/FreeCAD/tree/Beam_sections
IMHO we should not use radio buttons to choose the cross sections. We should go for a combobox and change the task panel depended on the chosen section type. Similar to Part --> create primitives.


For my first material refernce shape implementation I used such a task panel ui. https://github.com/berndhahnebach/FreeC ... aterial.ui You can open it in a simple ui - viewer and change the shapes of the model combo box
User avatar
bernd
Posts: 8233
Joined: Sun Sep 08, 2013 8:07 pm
Location: Zürich, Switzerland

Re: 3 Node Beam Elements not yet supported

Postby bernd » Tue Dec 13, 2016 12:18 pm

bernd wrote:
makkemal wrote:Some enhancement of beam sections allowing user to select circular and pipe beam sections
https://github.com/makkemal/FreeCAD/tree/Beam_sections
IMHO we should not use radio buttons to choose the cross sections. We should go for a combobox and change the task panel depended on the chosen section type. Similar to Part --> create primitives.


For my first material refernce shape implementation I used such a task panel ui. https://github.com/berndhahnebach/FreeC ... aterial.ui You can open it in a simple ui - viewer and change the shapes of the model combo box
try attached one in an ui viewer ...

remove .txt
TaskPanelFemBeamSection.ui.txt
(13.47 KiB) Downloaded 90 times
User avatar
bernd
Posts: 8233
Joined: Sun Sep 08, 2013 8:07 pm
Location: Zürich, Switzerland

Re: 3 Node Beam Elements not yet supported

Postby bernd » Tue Dec 13, 2016 4:20 pm

@makkemal:

try https://github.com/berndhahnebach/FreeC ... meshregion

the section type is not yet updated with the combo box from task panel, means the type has to be chosen in property editor, but all length values can be edited in task panel already.

bernd